import tensorflow.keras
from PIL import Image, ImageOps
import numpy as np
import RPi.GPIO as GPIO
import cv2
from picamera.array import PiRGBArray
from picamera import PiCamera
import time
from Poubelle import Poubelle






def init(pinInterupt):
    # configuration de la broche 7 en entree
    GPIO.setmode(GPIO.BCM)
    GPIO.setup(pinInterupt, GPIO.IN)
    # definition de l'interruption
    GPIO.add_event_detect(pinInterupt, GPIO.RISING, callback=detectionImage, bouncetime=300)
    print("Interruption configurée ")

def detectionImage(self):

    np.set_printoptions(suppress=True)

    # Create the array of the right shape to feed into the keras model
    # The 'length' or number of images you can put into the array is
    # determined by the first position in the shape tuple, in this case 1.
    data = np.ndarray(shape=(1, 224, 224, 3), dtype=np.float32)

    # prend une photo pour la detection au lieu d'une image déja présente sur disque dur

    # initialize the camera and grab a reference to the raw camera capture
    with PiCamera() as camera:
        rawCapture = PiRGBArray(camera)
        # allow the camera to warmup
        time.sleep(0.1)
        # grab an image from the camera
        camera.capture(rawCapture, format="bgr")
        image = rawCapture.array
        # display the image on screen and wait for a keypress

        cv2.imwrite('monImage.jpg', image)
        cv2.imshow("monImage.jpg", image)
        cv2.waitKey(0)
        cv2.destroyAllWindows()



        # image cv2
        cv2_im = cv2.imread('monImage.jpg', 0)
        cv2_im = cv2.cvtColor(cv2_im, cv2.COLOR_BGR2RGB)

        # image PIL
        pil_im = Image.fromarray(cv2_im)
        # Load the image into the array
        data[0] = prepare_normalized_image_array(pil_im)

        # run the iA keras model
        prediction = model.predict(data)
        # print("  ouvert :",prediction[0][0],end='\n')
        # print(" fermé :", prediction[0][1],end='\n')

        # prediction[0][0] -> canette -> vert
        # prediction[0][1] -> bouteille plastique -> jaune
        # prediction[0][2] -> rien

        canette, bouteille, rien , verre, journal = prediction[0]

        '''
                print(f"can -> {canette}")
                print(f"bouteille -> {bouteille}")
                print(f"rien {rien}")
                label.txt
                0 Cannette
                1 Bouteille
                2 Rien
                3 verre
                4 journal
        '''
        #recherche de la meilleure prédiction
        i = 0
        max = 0
        imax = -1
        for i in range(len(prediction[0])):
            if prediction[0][i] > max :
                max = prediction[0][i]
                imax = i


        if imax == 0:
            print("canette")
            pJaune.ouvrir()

        elif imax == 1:
            print("bouteille")
            pJaune.ouvrir()
        elif imax == 2 :
            print("rien")
            #pJaune.ouvrir()
        elif imax == 3 :
            print("verre")
            pVerte.ouvrir()
        elif imax == 4 :
            print("journal")
            pBleue.ouvrir()


def prepare_normalized_image_array(myVideoCapture):
    ''' Load the PIL image into an array '''
    image = myVideoCapture

    # Replace this with the path to your image
    # Make sure to resize all images to 224, 224 otherwise they won't fit in the array
    image = image.resize((224, 224))
    image_array = np.asarray(image)

    # Normalize the image
    normalized_image_array = (image_array.astype(np.float32) / 127.0) - 1

    return normalized_image_array


def setupGPIO():
    GPIO.setmode(GPIO.BCM)  # Use BCM Board numerotation mode
    # GPIO.setwarnings(False) #Disable warnings


if __name__ == '__main__':
    # 0- Load the model
    print("chargement du modele d'apprentissage")
    model = tensorflow.keras.models.load_model('keras_model.h5')
    print("fin du chargement du modele d'apprentissage")
    # 1- initiation de la l'interruption
    init(7)
    # 2- instanciation des poubelles
    setupGPIO()
    pJaune = Poubelle('jaune', 23)
    pVerte = Poubelle('verte', 24)
    pBleue = Poubelle('bleue', 25)
    #p2 = Poubelle('jaune')
    # 2- boucle infini = tache principale
    try:
        while True:
            pass
    # release the capture
    except KeyboardInterrupt:# If CTRL+C is pressed, exit cleanly:
        print("Keyboard interrupt")
        pJaune.stop()
        pVerte.stop()
        pBleue.stop()

    except:
        print("some error")

    finally:
        print("clean up")
        GPIO.cleanup() # cleanup all GPIO
        #cap.release()
        #cv2.destroyAllWindows()
